"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledListItem = exports.StyledListBox = exports.StyledInputContainer = exports.StyledRoot = void 0;

var _index = require("../input/index.js");

var _index2 = require("../styles/index.js");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StyledRoot = (0, _index2.styled)('div', {});
exports.StyledRoot = StyledRoot;
StyledRoot.displayName = "StyledRoot";
var StyledInputContainer = (0, _index2.styled)('div', {});
exports.StyledInputContainer = StyledInputContainer;
StyledInputContainer.displayName = "StyledInputContainer";
var StyledListBox = (0, _index2.styled)('ul', function (_ref) {
  var $theme = _ref.$theme,
      $width = _ref.$width;
  return {
    backgroundColor: $theme.colors.backgroundPrimary,
    marginBlockStart: 'unset',
    marginBlockEnd: 'unset',
    maxHeight: '200px',
    overflowY: 'auto',
    outline: 'none',
    paddingInlineStart: 'unset',
    width: $width
  };
});
exports.StyledListBox = StyledListBox;
StyledListBox.displayName = "StyledListBox";

function buildStylesForSize(size, theme) {
  switch (size) {
    case _index.SIZE.mini:
      return _objectSpread({}, theme.typography.ParagraphXSmall, {
        height: '30px',
        paddingLeft: theme.sizing.scale200
      });

    case _index.SIZE.compact:
      return _objectSpread({}, theme.typography.ParagraphSmall, {
        height: '36px',
        paddingLeft: theme.sizing.scale400
      });

    case _index.SIZE.large:
      return _objectSpread({}, theme.typography.ParagraphLarge, {
        height: '56px',
        paddingLeft: theme.sizing.scale650
      });

    case _index.SIZE.default:
    default:
      return _objectSpread({}, theme.typography.ParagraphMedium, {
        height: '48px',
        paddingLeft: theme.sizing.scale550
      });
  }
}

var StyledListItem = (0, _index2.styled)('li', function (_ref2) {
  var $isSelected = _ref2.$isSelected,
      $theme = _ref2.$theme,
      $size = _ref2.$size;
  return _objectSpread({}, buildStylesForSize($size, $theme), {
    alignItems: 'center',
    backgroundColor: $isSelected ? $theme.colors.comboboxListItemFocus : null,
    cursor: 'default',
    display: 'flex',
    listStyle: 'none',
    ':hover': {
      backgroundColor: $isSelected ? null : $theme.colors.comboboxListItemHover
    }
  });
});
exports.StyledListItem = StyledListItem;
StyledListItem.displayName = "StyledListItem";